# Class DefaultRequestedDate

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultRequestedDate

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `RequestedDate`

public class DefaultRequestedDate extends ISOMetadata implements RequestedDate
Range of date validity. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MI_RequestedDate` `├─requestedDateOfCollection……` Preferred date and time of collection. `└─latestAcceptableDate…………………` Latest date and time collection must be completed.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultRequestedDate()`
  Constructs an initially empty requested date.
  `DefaultRequestedDate(RequestedDate object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultRequestedDate`
  `castOrCopy(RequestedDate object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Date`
  `getLatestAcceptableDate()`
  Returns the latest date and time collection must be completed.
  `Date`
  `getRequestedDateOfCollection()`
  Returns the preferred date and time of collection.
  `void`
  `setLatestAcceptableDate(Temporal newValue)`
  Sets the latest date and time collection must be completed.
  `void`
  `setLatestAcceptableDate(Date newValue)`
  Deprecated.
  Replaced by `setLatestAcceptableDate(Temporal)`.
  `void`
  `setRequestedDateOfCollection(Temporal newValue)`
  Sets the preferred date and time of collection.
  `void`
  `setRequestedDateOfCollection(Date newValue)`
  Deprecated.
  Replaced by `setRequestedDateOfCollection(Temporal)`.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, clone, equals, equals, getInterface, hashCode, isEmpty, nilReasons, prune, toString`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultRequestedDate

    public DefaultRequestedDate()
    Constructs an initially empty requested date.

  - ### DefaultRequestedDate

    public DefaultRequestedDate(RequestedDate object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(RequestedDate)`

- ## Method Details

  - ### castOrCopy

    public static DefaultRequestedDate castOrCopy(RequestedDate object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultRequestedDate`, then it is returned unchanged.
    - Otherwise a new `DefaultRequestedDate` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getRequestedDateOfCollection

    public Date getRequestedDateOfCollection()
    Returns the preferred date and time of collection.
    Upcoming API change
    `Date` may be replaced by `Temporal` in GeoAPI 4.0.
    Specified by:
      `getRequestedDateOfCollection` in interface `RequestedDate`
    Returns:
      preferred date and time, or `null`.

  - ### setRequestedDateOfCollection

    public void setRequestedDateOfCollection(Temporal newValue)
    Sets the preferred date and time of collection. The specified value should be an instance of `LocalDate`, `LocalDateTime`, `OffsetDateTime` or `ZonedDateTime`, depending whether hours are defined and how the timezone (if any) is defined. But other types are also allowed.
    Parameters:
      `newValue` - the new requested date of collection value.
    Since:
      1.5

  - ### setRequestedDateOfCollection

    @Deprecated(since="1.5") public void setRequestedDateOfCollection(Date newValue)
    Deprecated.
    Replaced by `setRequestedDateOfCollection(Temporal)`.
    Sets the preferred date and time of collection.
    Parameters:
      `newValue` - the new requested date of collection value.

  - ### getLatestAcceptableDate

    public Date getLatestAcceptableDate()
    Returns the latest date and time collection must be completed.
    Upcoming API change
    `Date` may be replaced by `Temporal` in GeoAPI 4.0.
    Specified by:
      `getLatestAcceptableDate` in interface `RequestedDate`
    Returns:
      latest date and time, or `null`.

  - ### setLatestAcceptableDate

    public void setLatestAcceptableDate(Temporal newValue)
    Sets the latest date and time collection must be completed. The specified value should be an instance of `LocalDate`, `LocalDateTime`, `OffsetDateTime` or `ZonedDateTime`, depending whether hours are defined and how the timezone (if any) is defined. But other types are also allowed.
    Parameters:
      `newValue` - the new latest acceptable data value.
    Since:
      1.5

  - ### setLatestAcceptableDate

    @Deprecated(since="1.5") public void setLatestAcceptableDate(Date newValue)
    Deprecated.
    Replaced by `setLatestAcceptableDate(Temporal)`.
    Sets the latest date and time collection must be completed.
    Parameters:
      `newValue` - the new latest acceptable data value.